// Command.cpp: CCommand NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include <windows.h>
#include "Command.h"

CCommand::CCommand(int CommandID)
{
	m_CommandID = CommandID;
	m_Caption = "";
	m_Command = "";
	m_Parameter = "";
	m_Directory = "";
}

CCommand::~CCommand()
{
	//Ȃ
}

bool CCommand::GetIniData(const char *IniFileName, const char *AppName)
{
	bool ret = true;;

	//Iniw肵R}hID̒l擾
	char *buf, sCmdID[8];
	DWORD size = 1024, retsize;
	itoa(m_CommandID, sCmdID, 10);
	buf = (char *)malloc(size);
	retsize = ::GetPrivateProfileString(AppName, sCmdID, "", buf, size, IniFileName);
	while (retsize - 1 == size) {
		size += 1024;
		buf = (char *)realloc(buf, size);
		retsize = ::GetPrivateProfileString(AppName, sCmdID, "", buf, size, IniFileName);
	}
	std::string data = buf;
	free(buf);

	
	if (data.length() == 0) return false;

	//擾l|ŕB
	std::string::size_type index = 0;

	//Caption
	GetToken(data, m_Caption, index);
	if (m_Caption.length() == 0) return false;

	//Command
	if (index == data.npos) return false;
	GetToken(data, m_Command, index);
	ExpandEnv(m_Command);
	if (m_Command.length() == 0) return false;

	//Parameter
	if (index != data.npos) {
		GetToken(data, m_Parameter, index);
		ExpandEnv(m_Parameter);
	}

	//Directory
	if (index != data.npos) {
		GetToken(data, m_Directory, index);
		ExpandEnv(m_Directory);
	}

	return true;
}

bool CCommand::Execute(void)
{
	return (::ShellExecute(::GetDesktopWindow(), "open", m_Command.c_str(), m_Parameter.c_str(), m_Directory.c_str(), SW_SHOWNORMAL) > (HINSTANCE)32);
}

int CCommand::GetCommandID(void)
{
	return m_CommandID;
}

LPCSTR CCommand::GetCaption(void)
{
	return m_Caption.c_str();
}

void CCommand::ExpandEnv(std::string &str)
{
	char buff[MAX_PATH * 2];
	ExpandEnvironmentStrings(str.c_str(), buff, MAX_PATH * 2);
	str = buff;
}

void CCommand::GetToken(std::string str, std::string &result, std::string::size_type &index)
{
	std::string::size_type next = index;
	index = str.find_first_of("|", next);
	if (index == str.npos) {
		result = std::string(str.begin() + next, str.end());
	} else {
		result = std::string(str.begin() + next, str.begin() + index);
		index++;
	}
}
