#pragma once

#include <windows.h>


namespace MomoUtil {
	inline LPSTR GetIniFileName(HINSTANCE hInstance, LPSTR lpFileName, UINT uLen = MAX_PATH)
	{
		DWORD dwSize;
		dwSize = GetModuleFileName(hInstance, lpFileName, uLen - 1);
		lpFileName[dwSize - 3] = 'i';
		lpFileName[dwSize - 2] = 'n';
		lpFileName[dwSize - 1] = 'i';

		return lpFileName;
	}


	inline LPFILETIME GetFileTime(LPCSTR lpFileName, LPFILETIME lpFileTime)
	{
		lpFileTime->dwHighDateTime = 0;
		lpFileTime->dwLowDateTime = 0;

		HANDLE hFile = CreateFile(lpFileName
								, GENERIC_READ, 0
								, 0, OPEN_EXISTING
								, 0, NULL);
		if (hFile != INVALID_HANDLE_VALUE) {
			::GetFileTime(hFile, NULL, NULL, lpFileTime);
			CloseHandle(hFile);
		}
		return lpFileTime;
	}
}